#ifndef __INCLUDE_DDK_STATUS_H
#define __INCLUDE_DDK_STATUS_H

#define NTSTAT_SEVERITY_SHIFT 30
#define NTSTAT_SEVERITY_MASK  0x00000003
#define NTSTAT_FACILITY_SHIFT 16
#define NTSTAT_FACILITY_MASK  0x00000FFF
#define NTSTAT_CUSTOMER_MASK  0x20000000

#define NT_SEVERITY(StatCode) (((StatCode) >> NTSTAT_SEVERITY_SHIFT) & NTSTAT_SEVERITY_MASK)
#define NT_FACILITY(StatCode) (((StatCode) >> NTSTAT_FACILITY_SHIFT) & NTSTAT_FACILITY_MASK)
#define NT_CUSTOMER(StatCode) ((StatCode) & NTSTAT_CUSTOMER_MASK)
#define NT_SUCCESS(StatCode)  ((NTSTATUS)(StatCode) >= 0)

/*
 * Possible status codes
 * FIXME: These may not be the actual values used by NT
 */
enum
{
   STATUS_SUCCESS = 0x0,


 STATUS_MORE_ENTRIES=0x00000105,
 STATUS_NOTIFY_ENUM_DIR=0x0000010C,



 STATUS_OBJECT_NAME_EXISTS=0x40000000,
 STATUS_THREAD_WAS_SUSPENDED,
 STATUS_WORKING_SET_LIMIT_RANGE,
 STATUS_IMAGE_NOT_AT_BASE,
 STATUS_RXACT_STATE_CREATED,
 STATUS_SEGMENT_NOTIFICATION,
 STATUS_LOCAL_USER_SESSION_KEY,
 STATUS_BAD_CURRENT_DIRECTORY,
 STATUS_SERIAL_MORE_WRITES,
 STATUS_REGISTRY_RECOVERED,
 STATUS_FT_READ_RECOVERY_FROM_BACKUP,
 STATUS_FT_WRITE_RECOVERY,
 STATUS_SERIAL_COUNTER_TIMEOUT,
 STATUS_NULL_LM_PASSWORD,
 STATUS_IMAGE_MACHINE_TYPE_MISMATCH,
 STATUS_RECEIVE_PARTIAL,
 STATUS_RECEIVE_EXPEDITED,
 STATUS_RECEIVE_PARTIAL_EXPEDITED,
 STATUS_EVENT_DONE,
 STATUS_EVENT_PENDING,
 STATUS_CHECKING_FILE_SYSTEM,
 STATUS_FATAL_APP_EXIT,
 STATUS_PREDEFINED_HANDLE,
 STATUS_WAS_UNLOCKED,
 STATUS_SERVICE_NOTIFICATION,
 STATUS_WAS_LOCKED,
 STATUS_LOG_HARD_ERROR,
 STATUS_ALREADY_WIN32,
 STATUS_WX86_UNSIMULATE,
 STATUS_WX86_CONTINUE,
 STATUS_WX86_SINGLE_STEP,
 STATUS_WX86_BREAKPOINT,
 STATUS_WX86_EXCEPTION_CONTINUE,
 STATUS_WX86_EXCEPTION_LASTCHANCE,
 STATUS_WX86_EXCEPTION_CHAIN,
 STATUS_IMAGE_MACHINE_TYPE_MISMATCH_EXE,
 STATUS_NO_YIELD_PERFORMED,
 STATUS_TIMER_RESUME_IGNORED,
 STATUS_ARBITRATION_UNHANDLED,
 STATUS_CARDBUS_NOT_SUPPORTED,
 STATUS_WX86_CREATEWX86TIB,


 STATUS_GUARD_PAGE_VIOLATION=0x80000001,
 STATUS_DATATYPE_MISALIGNMENT,
 STATUS_BREAKPOINT,
 STATUS_SINGLE_STEP,
 STATUS_BUFFER_OVERFLOW,
 STATUS_NO_MORE_FILES,
 STATUS_WAKE_SYSTEM_DEBUGGER,


 STATUS_HANDLES_CLOSED=0x8000000A,
 STATUS_NO_INHERITANCE,
 STATUS_GUID_SUBSTITUTION_MADE,
 STATUS_PARTIAL_COPY,
 STATUS_DEVICE_PAPER_EMPTY,
 STATUS_DEVICE_POWERED_OFF,
 STATUS_DEVICE_OFF_LINE,
 STATUS_DEVICE_BUSY,
 STATUS_NO_MORE_EAS,
 STATUS_INVALID_EA_NAME,
 STATUS_EA_LIST_INCONSISTENT,
 STATUS_INVALID_EA_FLAG,
 STATUS_VERIFY_REQUIRED,
 STATUS_EXTRANEOUS_INFORMATION,
 STATUS_RXACT_COMMIT_NECESSARY,

 STATUS_NO_MORE_ENTRIES=0x8000001A,
 STATUS_FILEMARK_DETECTED,
 STATUS_MEDIA_CHANGED,
 STATUS_BUS_RESET,
 STATUS_END_OF_MEDIA,
 STATUS_BEGINNING_OF_MEDIA,
 STATUS_MEDIA_CHECK,
 STATUS_SETMARK_DETECTED,
 STATUS_NO_DATA_DETECTED,
 STATUS_REDIRECTOR_HAS_OPEN_HANDLES,
 STATUS_SERVER_HAS_OPEN_HANDLES,
 STATUS_ALREADY_DISCONNECTED,
 STATUS_LONGJUMP,

   STATUS_UNSUCCESSFUL=0xC0000001,
 STATUS_NOT_IMPLEMENTED,
 STATUS_INVALID_INFO_CLASS,
 STATUS_INFO_LENGTH_MISMATCH,
 STATUS_ACCESS_VIOLATION,
 STATUS_IN_PAGE_ERROR,
 STATUS_PAGEFILE_QUOTA,
 STATUS_INVALID_HANDLE,
 STATUS_BAD_INITIAL_STACK,
 STATUS_BAD_INITIAL_PC,
 STATUS_INVALID_CID,
 STATUS_TIMER_NOT_CANCELED,
 STATUS_INVALID_PARAMETER,
 STATUS_NO_SUCH_DEVICE,
 STATUS_NO_SUCH_FILE,
 STATUS_INVALID_DEVICE_REQUEST,
 STATUS_END_OF_FILE,
 STATUS_WRONG_VOLUME,
 STATUS_NO_MEDIA_IN_DEVICE,
 STATUS_UNRECOGNIZED_MEDIA,
 STATUS_NONEXISTENT_SECTOR,
 STATUS_MORE_PROCESSING_REQUIRED,
 STATUS_NO_MEMORY,
 STATUS_CONFLICTING_ADDRESSES,
 STATUS_NOT_MAPPED_VIEW,
 STATUS_UNABLE_TO_FREE_VM,
 STATUS_UNABLE_TO_DELETE_SECTION,
 STATUS_INVALID_SYSTEM_SERVICE,
 STATUS_ILLEGAL_INSTRUCTION,
 STATUS_INVALID_LOCK_SEQUENCE,
 STATUS_INVALID_VIEW_SIZE,
 STATUS_INVALID_FILE_FOR_SECTION,
 STATUS_ALREADY_COMMITTED,
 STATUS_ACCESS_DENIED,
 STATUS_BUFFER_TOO_SMALL,
 STATUS_OBJECT_TYPE_MISMATCH,
 STATUS_NONCONTINUABLE_EXCEPTION,
 STATUS_INVALID_DISPOSITION,
 STATUS_UNWIND,
 STATUS_BAD_STACK,
 STATUS_INVALID_UNWIND_TARGET,
 STATUS_NOT_LOCKED,
 STATUS_PARITY_ERROR,
 STATUS_UNABLE_TO_DECOMMIT_VM,
 STATUS_NOT_COMMITTED,
 STATUS_INVALID_PORT_ATTRIBUTES,
 STATUS_PORT_MESSAGE_TOO_LONG,
 STATUS_INVALID_PARAMETER_MIX,
 STATUS_INVALID_QUOTA_LOWER,
 STATUS_DISK_CORRUPT_ERROR,
 STATUS_OBJECT_NAME_INVALID,
 STATUS_OBJECT_NAME_NOT_FOUND,
 STATUS_OBJECT_NAME_COLLISION,

 STATUS_PORT_DISCONNECTED=0xC0000037L,
 STATUS_DEVICE_ALREADY_ATTACHED,
 STATUS_OBJECT_PATH_INVALID,
 STATUS_OBJECT_PATH_NOT_FOUND,
 STATUS_OBJECT_PATH_SYNTAX_BAD,
 STATUS_DATA_OVERRUN,
 STATUS_DATA_LATE_ERROR,
 STATUS_DATA_ERROR,
 STATUS_CRC_ERROR,
 STATUS_SECTION_TOO_BIG,
 STATUS_PORT_CONNECTION_REFUSED,
 STATUS_INVALID_PORT_HANDLE,
 STATUS_SHARING_VIOLATION,
 STATUS_QUOTA_EXCEEDED,
 STATUS_INVALID_PAGE_PROTECTION,
 STATUS_MUTANT_NOT_OWNED,
 STATUS_SEMAPHORE_LIMIT_EXCEEDED,
 STATUS_PORT_ALREADY_SET,
 STATUS_SECTION_NOT_IMAGE,
 STATUS_SUSPEND_COUNT_EXCEEDED,
 STATUS_THREAD_IS_TERMINATING,
 STATUS_BAD_WORKING_SET_LIMIT,
 STATUS_INCOMPATIBLE_FILE_MAP,
 STATUS_SECTION_PROTECTION,
 STATUS_EAS_NOT_SUPPORTED,
 STATUS_EA_TOO_LARGE,
 STATUS_NONEXISTENT_EA_ENTRY,
 STATUS_NO_EAS_ON_FILE,
 STATUS_EA_CORRUPT_ERROR,
 STATUS_FILE_LOCK_CONFLICT,
 STATUS_LOCK_NOT_GRANTED,
 STATUS_DELETE_PENDING,
 STATUS_CTL_FILE_NOT_SUPPORTED,
 STATUS_UNKNOWN_REVISION,
 STATUS_REVISION_MISMATCH,
 STATUS_INVALID_OWNER,
 STATUS_INVALID_PRIMARY_GROUP,
 STATUS_NO_IMPERSONATION_TOKEN,
 STATUS_CANT_DISABLE_MANDATORY,
 STATUS_NO_LOGON_SERVERS,
 STATUS_NO_SUCH_LOGON_SESSION,
 STATUS_NO_SUCH_PRIVILEGE,
 STATUS_PRIVILEGE_NOT_HELD,
 STATUS_INVALID_ACCOUNT_NAME,
 STATUS_USER_EXISTS,
 STATUS_NO_SUCH_USER,
 STATUS_GROUP_EXISTS,
 STATUS_NO_SUCH_GROUP,
 STATUS_MEMBER_IN_GROUP,
 STATUS_MEMBER_NOT_IN_GROUP,
 STATUS_LAST_ADMIN,
 STATUS_WRONG_PASSWORD,
 STATUS_ILL_FORMED_PASSWORD,
 STATUS_PASSWORD_RESTRICTION,
 STATUS_LOGON_FAILURE,
 STATUS_ACCOUNT_RESTRICTION,
 STATUS_INVALID_LOGON_HOURS,
 STATUS_INVALID_WORKSTATION,
 STATUS_PASSWORD_EXPIRED,
 STATUS_ACCOUNT_DISABLED,
 STATUS_NONE_MAPPED,
 STATUS_TOO_MANY_LUIDS_REQUESTED,
 STATUS_LUIDS_EXHAUSTED,
 STATUS_INVALID_SUB_AUTHORITY,
 STATUS_INVALID_ACL,
 STATUS_INVALID_SID,
 STATUS_INVALID_SECURITY_DESCR,
 STATUS_PROCEDURE_NOT_FOUND,
 STATUS_INVALID_IMAGE_FORMAT,
 STATUS_NO_TOKEN,
 STATUS_BAD_INHERITANCE_ACL,
 STATUS_RANGE_NOT_LOCKED,
 STATUS_DISK_FULL,
 STATUS_SERVER_DISABLED,
 STATUS_SERVER_NOT_DISABLED,
 STATUS_TOO_MANY_GUIDS_REQUESTED,
 STATUS_GUIDS_EXHAUSTED,
 STATUS_INVALID_ID_AUTHORITY,
 STATUS_AGENTS_EXHAUSTED,
 STATUS_INVALID_VOLUME_LABEL,
 STATUS_SECTION_NOT_EXTENDED,
 STATUS_NOT_MAPPED_DATA,
 STATUS_RESOURCE_DATA_NOT_FOUND,
 STATUS_RESOURCE_TYPE_NOT_FOUND,
 STATUS_RESOURCE_NAME_NOT_FOUND,
 STATUS_ARRAY_BOUNDS_EXCEEDED,
 STATUS_FLOAT_DENORMAL_OPERAND,
 STATUS_FLOAT_DIVIDE_BY_ZERO,
 STATUS_FLOAT_INEXACT_RESULT,
 STATUS_FLOAT_INVALID_OPERATION,
 STATUS_FLOAT_OVERFLOW,
 STATUS_FLOAT_STACK_CHECK,
 STATUS_FLOAT_UNDERFLOW,
 STATUS_INTEGER_DIVIDE_BY_ZERO,
 STATUS_INTEGER_OVERFLOW,
 STATUS_PRIVILEGED_INSTRUCTION,
 STATUS_TOO_MANY_PAGING_FILES,
 STATUS_FILE_INVALID,
 STATUS_ALLOTTED_SPACE_EXCEEDED,
 STATUS_INSUFFICIENT_RESOURCES,
 STATUS_DFS_EXIT_PATH_FOUND,
 STATUS_DEVICE_DATA_ERROR,
 STATUS_DEVICE_NOT_CONNECTED,
 STATUS_DEVICE_POWER_FAILURE,
 STATUS_FREE_VM_NOT_AT_BASE,
 STATUS_MEMORY_NOT_ALLOCATED,
 STATUS_WORKING_SET_QUOTA,
 STATUS_MEDIA_WRITE_PROTECTED,
 STATUS_DEVICE_NOT_READY,
 STATUS_INVALID_GROUP_ATTRIBUTES,
 STATUS_BAD_IMPERSONATION_LEVEL,
 STATUS_CANT_OPEN_ANONYMOUS,
 STATUS_BAD_VALIDATION_CLASS,
 STATUS_BAD_TOKEN_TYPE,
 STATUS_BAD_MASTER_BOOT_RECORD,
 STATUS_INSTRUCTION_MISALIGNMENT,
 STATUS_INSTANCE_NOT_AVAILABLE,
 STATUS_PIPE_NOT_AVAILABLE,
 STATUS_INVALID_PIPE_STATE,
 STATUS_PIPE_BUSY,
 STATUS_ILLEGAL_FUNCTION,
 STATUS_PIPE_DISCONNECTED,
 STATUS_PIPE_CLOSING,
 STATUS_PIPE_CONNECTED,
 STATUS_PIPE_LISTENING,
 STATUS_INVALID_READ_MODE,
 STATUS_IO_TIMEOUT,
 STATUS_FILE_FORCED_CLOSED,
 STATUS_PROFILING_NOT_STARTED,
 STATUS_PROFILING_NOT_STOPPED,
 STATUS_COULD_NOT_INTERPRET,
 STATUS_FILE_IS_A_DIRECTORY,
 STATUS_NOT_SUPPORTED,
 STATUS_REMOTE_NOT_LISTENING,
 STATUS_DUPLICATE_NAME,
 STATUS_BAD_NETWORK_PATH,
 STATUS_NETWORK_BUSY,
 STATUS_DEVICE_DOES_NOT_EXIST,
 STATUS_TOO_MANY_COMMANDS,
 STATUS_ADAPTER_HARDWARE_ERROR,
 STATUS_INVALID_NETWORK_RESPONSE,
 STATUS_UNEXPECTED_NETWORK_ERROR,
 STATUS_BAD_REMOTE_ADAPTER,
 STATUS_PRINT_QUEUE_FULL,
 STATUS_NO_SPOOL_SPACE,
 STATUS_PRINT_CANCELLED,
 STATUS_NETWORK_NAME_DELETED,
 STATUS_NETWORK_ACCESS_DENIED,
 STATUS_BAD_DEVICE_TYPE,
 STATUS_BAD_NETWORK_NAME,
 STATUS_TOO_MANY_NAMES,
 STATUS_TOO_MANY_SESSIONS,
 STATUS_SHARING_PAUSED,
 STATUS_REQUEST_NOT_ACCEPTED,
 STATUS_REDIRECTOR_PAUSED,
 STATUS_NET_WRITE_FAULT,
 STATUS_PROFILING_AT_LIMIT,
 STATUS_NOT_SAME_DEVICE,
 STATUS_FILE_RENAMED,
 STATUS_VIRTUAL_CIRCUIT_CLOSED,
 STATUS_NO_SECURITY_ON_OBJECT,
 STATUS_CANT_WAIT,
 STATUS_PIPE_EMPTY,
 STATUS_CANT_ACCESS_DOMAIN_INFO,
 STATUS_CANT_TERMINATE_SELF,
 STATUS_INVALID_SERVER_STATE,
 STATUS_INVALID_DOMAIN_STATE,
 STATUS_INVALID_DOMAIN_ROLE,
 STATUS_NO_SUCH_DOMAIN,
 STATUS_DOMAIN_EXISTS,
 STATUS_DOMAIN_LIMIT_EXCEEDED,
 STATUS_OPLOCK_NOT_GRANTED,
 STATUS_INVALID_OPLOCK_PROTOCOL,
 STATUS_INTERNAL_DB_CORRUPTION,
 STATUS_INTERNAL_ERROR,
 STATUS_GENERIC_NOT_MAPPED,
 STATUS_BAD_DESCRIPTOR_FORMAT,
 STATUS_INVALID_USER_BUFFER,
 STATUS_UNEXPECTED_IO_ERROR,
 STATUS_UNEXPECTED_MM_CREATE_ERR,
 STATUS_UNEXPECTED_MM_MAP_ERROR,
 STATUS_UNEXPECTED_MM_EXTEND_ERR,
 STATUS_NOT_LOGON_PROCESS,
 STATUS_LOGON_SESSION_EXISTS,
 STATUS_INVALID_PARAMETER_1,
 STATUS_INVALID_PARAMETER_2,
 STATUS_INVALID_PARAMETER_3,
 STATUS_INVALID_PARAMETER_4,
 STATUS_INVALID_PARAMETER_5,
 STATUS_INVALID_PARAMETER_6,
 STATUS_INVALID_PARAMETER_7,
 STATUS_INVALID_PARAMETER_8,
 STATUS_INVALID_PARAMETER_9,
 STATUS_INVALID_PARAMETER_10,
 STATUS_INVALID_PARAMETER_11,
 STATUS_INVALID_PARAMETER_12,
 STATUS_REDIRECTOR_NOT_STARTED,
 STATUS_REDIRECTOR_STARTED,
 STATUS_STACK_OVERFLOW,
 STATUS_NO_SUCH_PACKAGE,
 STATUS_BAD_FUNCTION_TABLE,
 STATUS_VARIABLE_NOT_FOUND,
 STATUS_DIRECTORY_NOT_EMPTY,
 STATUS_FILE_CORRUPT_ERROR,
 STATUS_NOT_A_DIRECTORY,
 STATUS_BAD_LOGON_SESSION_STATE,
 STATUS_LOGON_SESSION_COLLISION,
 STATUS_NAME_TOO_LONG,
 STATUS_FILES_OPEN,
 STATUS_CONNECTION_IN_USE,
 STATUS_MESSAGE_NOT_FOUND,
 STATUS_PROCESS_IS_TERMINATING,
 STATUS_INVALID_LOGON_TYPE,
 STATUS_NO_GUID_TRANSLATION,
 STATUS_CANNOT_IMPERSONATE,
 STATUS_IMAGE_ALREADY_LOADED,
 STATUS_ABIOS_NOT_PRESENT,
 STATUS_ABIOS_LID_NOT_EXIST,
 STATUS_ABIOS_LID_ALREADY_OWNED,
 STATUS_ABIOS_NOT_LID_OWNER,
 STATUS_ABIOS_INVALID_COMMAND,
 STATUS_ABIOS_INVALID_LID,
 STATUS_ABIOS_SELECTOR_NOT_AVAILABLE,
 STATUS_ABIOS_INVALID_SELECTOR,
 STATUS_NO_LDT,
 STATUS_INVALID_LDT_SIZE,
 STATUS_INVALID_LDT_OFFSET,
 STATUS_INVALID_LDT_DESCRIPTOR,
 STATUS_INVALID_IMAGE_NE_FORMAT,
 STATUS_RXACT_INVALID_STATE,
 STATUS_RXACT_COMMIT_FAILURE,
 STATUS_MAPPED_FILE_SIZE_ZERO,
 STATUS_TOO_MANY_OPENED_FILES,
 STATUS_CANCELLED,
 STATUS_CANNOT_DELETE,
 STATUS_INVALID_COMPUTER_NAME,
 STATUS_FILE_DELETED,
 STATUS_SPECIAL_ACCOUNT,
 STATUS_SPECIAL_GROUP,
 STATUS_SPECIAL_USER,
 STATUS_MEMBERS_PRIMARY_GROUP,
 STATUS_FILE_CLOSED,
 STATUS_TOO_MANY_THREADS,
 STATUS_THREAD_NOT_IN_PROCESS,
 STATUS_TOKEN_ALREADY_IN_USE,
 STATUS_PAGEFILE_QUOTA_EXCEEDED,
 STATUS_COMMITMENT_LIMIT,
 STATUS_INVALID_IMAGE_LE_FORMAT,
 STATUS_INVALID_IMAGE_NOT_MZ,
 STATUS_INVALID_IMAGE_PROTECT,
 STATUS_INVALID_IMAGE_WIN_16,
 STATUS_LOGON_SERVER_CONFLICT,
 STATUS_TIME_DIFFERENCE_AT_DC,
 STATUS_SYNCHRONIZATION_REQUIRED,
 STATUS_DLL_NOT_FOUND,
 STATUS_OPEN_FAILED,
 STATUS_IO_PRIVILEGE_FAILED,
 STATUS_ORDINAL_NOT_FOUND,
 STATUS_ENTRYPOINT_NOT_FOUND,
 STATUS_CONTROL_C_EXIT,
 STATUS_LOCAL_DISCONNECT,
 STATUS_REMOTE_DISCONNECT,
 STATUS_REMOTE_RESOURCES,
 STATUS_LINK_FAILED,
 STATUS_LINK_TIMEOUT,
 STATUS_INVALID_CONNECTION,
 STATUS_INVALID_ADDRESS,
 STATUS_DLL_INIT_FAILED,
 STATUS_MISSING_SYSTEMFILE,
 STATUS_UNHANDLED_EXCEPTION,
 STATUS_APP_INIT_FAILURE,
 STATUS_PAGEFILE_CREATE_FAILED,
 STATUS_NO_PAGEFILE,
 STATUS_INVALID_LEVEL,
 STATUS_WRONG_PASSWORD_CORE,
 STATUS_ILLEGAL_FLOAT_CONTEXT,
 STATUS_PIPE_BROKEN,
 STATUS_REGISTRY_CORRUPT,
 STATUS_REGISTRY_IO_FAILED,
 STATUS_NO_EVENT_PAIR,
 STATUS_UNRECOGNIZED_VOLUME,
 STATUS_SERIAL_NO_DEVICE_INITED,
 STATUS_NO_SUCH_ALIAS,
 STATUS_MEMBER_NOT_IN_ALIAS,
 STATUS_MEMBER_IN_ALIAS,
 STATUS_ALIAS_EXISTS,
 STATUS_LOGON_NOT_GRANTED,
 STATUS_TOO_MANY_SECRETS,
 STATUS_SECRET_TOO_LONG,
 STATUS_INTERNAL_DB_ERROR,
 STATUS_FULLSCREEN_MODE,
 STATUS_TOO_MANY_CONTEXT_IDS,
 STATUS_LOGON_TYPE_NOT_GRANTED,
 STATUS_NOT_REGISTRY_FILE,
 STATUS_NT_CROSS_ENCRYPTION_REQUIRED,
 STATUS_DOMAIN_CTRLR_CONFIG_ERROR,
 STATUS_FT_MISSING_MEMBER,
 STATUS_ILL_FORMED_SERVICE_ENTRY,
 STATUS_ILLEGAL_CHARACTER,
 STATUS_UNMAPPABLE_CHARACTER,
 STATUS_UNDEFINED_CHARACTER,
 STATUS_FLOPPY_VOLUME,
 STATUS_FLOPPY_ID_MARK_NOT_FOUND,
 STATUS_FLOPPY_WRONG_CYLINDER,
 STATUS_FLOPPY_UNKNOWN_ERROR,
 STATUS_FLOPPY_BAD_REGISTERS,
 STATUS_DISK_RECALIBRATE_FAILED,
 STATUS_DISK_OPERATION_FAILED,
 STATUS_DISK_RESET_FAILED,
 STATUS_SHARED_IRQ_BUSY,
 STATUS_FT_ORPHANING,
 STATUS_BIOS_FAILED_TO_CONNECT_INTERRUPT,



 STATUS_PARTITION_FAILURE=0xC0000172,
 STATUS_INVALID_BLOCK_LENGTH,
 STATUS_DEVICE_NOT_PARTITIONED,
 STATUS_UNABLE_TO_LOCK_MEDIA,
 STATUS_UNABLE_TO_UNLOAD_MEDIA,
 STATUS_EOM_OVERFLOW,
 STATUS_NO_MEDIA,

 STATUS_NO_SUCH_MEMBER=0xC000017A,
 STATUS_INVALID_MEMBER,
 STATUS_KEY_DELETED,
 STATUS_NO_LOG_SPACE,
 STATUS_TOO_MANY_SIDS,
 STATUS_LM_CROSS_ENCRYPTION_REQUIRED,
 STATUS_KEY_HAS_CHILDREN,
 STATUS_CHILD_MUST_BE_VOLATILE,
 STATUS_DEVICE_CONFIGURATION_ERROR,
 STATUS_DRIVER_INTERNAL_ERROR,
 STATUS_INVALID_DEVICE_STATE,
 STATUS_IO_DEVICE_ERROR,
 STATUS_DEVICE_PROTOCOL_ERROR,
 STATUS_BACKUP_CONTROLLER,
 STATUS_LOG_FILE_FULL,
 STATUS_TOO_LATE,
 STATUS_NO_TRUST_LSA_SECRET,
 STATUS_NO_TRUST_SAM_ACCOUNT,
 STATUS_TRUSTED_DOMAIN_FAILURE,
 STATUS_TRUSTED_RELATIONSHIP_FAILURE,
 STATUS_EVENTLOG_FILE_CORRUPT,
 STATUS_EVENTLOG_CANT_START,
 STATUS_TRUST_FAILURE,
 STATUS_MUTANT_LIMIT_EXCEEDED,
 STATUS_NETLOGON_NOT_STARTED,
 STATUS_ACCOUNT_EXPIRED,
 STATUS_POSSIBLE_DEADLOCK,
 STATUS_NETWORK_CREDENTIAL_CONFLICT,
 STATUS_REMOTE_SESSION_LIMIT,
 STATUS_EVENTLOG_FILE_CHANGED,
 STATUS_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT,
 STATUS_NOLOGON_WORKSTATION_TRUST_ACCOUNT,
 STATUS_NOLOGON_SERVER_TRUST_ACCOUNT,
 STATUS_DOMAIN_TRUST_INCONSISTENT,
 STATUS_FS_DRIVER_REQUIRED,

 STATUS_RESOURCE_LANG_NOT_FOUND=0xC0000204,


 RPC_NT_INVALID_STRING_BINDING=0xC0020001,
 RPC_NT_WRONG_KIND_OF_BINDING,
 RPC_NT_INVALID_BINDING,
 RPC_NT_PROTSEQ_NOT_SUPPORTED,
 RPC_NT_INVALID_RPC_PROTSEQ,
 RPC_NT_INVALID_STRING_UUID,
 RPC_NT_INVALID_ENDPOINT_FORMAT,
 RPC_NT_INVALID_NET_ADDR,
 RPC_NT_NO_ENDPOINT_FOUND,
 RPC_NT_INVALID_TIMEOUT,
 RPC_NT_OBJECT_NOT_FOUND,
 RPC_NT_ALREADY_REGISTERED,
 RPC_NT_TYPE_ALREADY_REGISTERED,
 RPC_NT_ALREADY_LISTENING,
 RPC_NT_NO_PROTSEQS_REGISTERED,
 RPC_NT_NOT_LISTENING,
 RPC_NT_UNKNOWN_MGR_TYPE,
 RPC_NT_UNKNOWN_IF,
 RPC_NT_NO_BINDINGS,
 RPC_NT_NO_PROTSEQS,
 RPC_NT_CANT_CREATE_ENDPOINT,
 RPC_NT_OUT_OF_RESOURCES,
 RPC_NT_SERVER_UNAVAILABLE,
 RPC_NT_SERVER_TOO_BUSY,
 RPC_NT_INVALID_NETWORK_OPTIONS,
 RPC_NT_NO_CALL_ACTIVE,
 RPC_NT_CALL_FAILED,
 RPC_NT_CALL_FAILED_DNE,
 RPC_NT_PROTOCOL_ERROR,


 RPC_NT_SS_IN_NULL_CONTEXT=0xC0030004,

     /*
      * Reactos codes
      */
     STATUS_FS_QUERY_REQUIRED,
   STATUS_HANDLE_NOT_WAITABLE,//FIXME
   STATUS_OBJECT_FILE_MISMATCH,//FIXME
   STATUS_INVALID_PARAMETER_MAX,//FIXME
   STATUS_CONFLICTING_ADDRESS,//FIXME : ADDRESSES ?
   STATUS_NO_MEDIA_IN_DRIVE,//FIXME : no_media or no_media_in_device ?
};

#endif /* __INCLUDE_DDK_STATUS_H */






